  LIB "dmodapp.lib";


  ring r;
  qring Q = x;
  intvec V = option(get);
  ideal I = 0; 
  I = engine(I, 0);
  I = engine(I, 1);
  I = engine(I, 2);
  if( option(get) != V )
  {

    "BUG: engine changes options: ";

    "New: ";
    option();
    "Old: ";
    option(set, V);
    option();
  }
  


  "EXAMPLE:"; echo = 2;
  ring @D = 0,(x,y,Dx,Dy),dp;
  def D = Weyl();
  setring D;
  poly F = 3*x^2*Dy+2*y*Dx;
  poly G = 2*x*Dx+3*y*Dy+6;
  ideal I = F,G;
  intvec w1 = -1,-1,1,1;
  intvec w2 = -1,-2,1,2;
  intvec w3 = -2,-3,2,3;
  inForm(I,w1);
  inForm(I,w2);
  inForm(I,w3);
  inForm(F,w1);
  poly Z = 0;
  inForm(Z,w1); // TODO: FIX THIS BUG: index[0] must be positive
  inForm(poly(0),w1); // TODO: FIX THIS BUG: index[0] must be positive
  inForm(0,w1); // TODO: FIX THIS BUG: index[0] must be positive


  kill basering;




 "EXAMPLE:"; echo = 2;
  ring r = 0,x,dp;
  poly F = x;
  poly2list(F);
  ring r2 = 0,(x,y),dp;
  poly F = x2y-x*y2;
  poly2list(F);
  poly Z = 0;
  poly2list(Z); // TODO: FIX THIS BUG: index[0] must be positive
  poly2list(poly(0)); // TODO: FIX THIS BUG: index[0] must be positive
  poly2list(0); // TODO: FIX THIS BUG: index[0] must be positive



  kill basering;


 "EXAMPLE:"; echo = 2;
  ring r = 0,(x,y,Dx,Dy),dp;
  def R = Weyl();    setring R;
  ideal BS; // TODO: THIS LEADS TO A PARSE ERROR!!! PLEASE, FIX!
  poly F = x2-y3;
  ideal I = (y^3 - x^2)*Dx - 2*x, (y^3 - x^2)*Dy + 3*y^2; // I = Dx*F, Dy*F;
  DLoc(I, x2-y3);


  kill basering;





  "EXAMPLE:"; echo = 2;



  ring t = 0, (@t, @Dt, s), dp; //  @t, @Dt, s // This assumption is no documented!!!
  ring r = 0,(x,y,Dx,Dy),dp;
  def R = Weyl(); R = R + t;  setring R;  R;

  poly F = x2-y3;
  ideal I = Dx*F, Dy*F;

  def W = SDLoc(I,F); // 
  setring W; W;  listvar(W);  kill W;


  def W = DLoc0(I,F);
  setring W; W;  listvar(W);  kill W;

  kill r, t;



  ring t1 = 0, (@t), dp; 
  ring t2 = 0, (@Dt), dp;
  ring t3 = 0, (s), dp; 
  ring r = 0,(x,y,Dx,Dy),dp;
  def R = Weyl(); 
  def R1 = R + t1;
  def R2 = R + t2;
  def R3 = R + t3;

  setring R1; R1;
  poly F = x2-y3;
  ideal I = Dx*F, Dy*F;
  def W = SDLoc(I,F); // last variable name is not checked!!!???
  setring W; W;  listvar(W);  kill W;


  def W = DLoc0(I,F);
  setring W; W;  listvar(W);  kill W;


  setring R2; R2;
  poly F = x2-y3;
  ideal I = Dx*F, Dy*F;
  def W = SDLoc(I,F); // last variable name is not checked!!!???
  setring W; W;  listvar(W);  kill W;


  def W = DLoc0(I,F);
  setring W; W;  listvar(W);  kill W;



  setring R3; R3;
  poly F = x2-y3;
  ideal I = Dx*F, Dy*F;
  def W = SDLoc(I,F); // last variable name is not checked!!!???
  setring W; W;  listvar(W);  kill W;


  def W = DLoc0(I,F);
  setring W; W;  listvar(W);  kill W;
  

  kill R, R3, R2, R1, t3, t2, t1, r;




  ring r = (111, @t, @Dt, s, D, DD),(x,y,Dx,Dy),dp;
  def R = Weyl();
  setring R; R;
  poly F = x2-y3;
  ideal I = Dx*F, Dy*F;
  def W = SDLoc(I,F);
  setring W; W;  listvar(W);  kill W;

  def W = DLoc0(I,F);
  setring W; W;  listvar(W);  kill W;



  kill R, r;




  "EXAMPLE:"; echo = 2;
  ring r = (111, Dx, Dy, Dz),(x,y,z, D, DD, DDD),dp;
  poly f = x^2*z - y^3;
  def A = annPoly(f); setring A; 
  A; "";
  LD;
// TODO: SINCE THE FOLLOWING DOES NOT YIELD ZERO - THE MEANING OF ANNIHILATOR IS NOT CLEAR!
// IS THERE ANY WAY TO CHECK THAT THIS IS AN ANNIHILATOR OF f?
  LD * imap(r, f);
  gkdim(LD); // must be 3 since LD is holonomic, TODO: WHY IS THIS? PLEASE REFERENCE!
  NF(Dy^4, LD); // must be 0 since Dy^4 clearly annihilates f


  kill basering, r;






  "EXAMPLE:"; echo = 2;
  ring r = 0,(x,y,z),dp;
  int J = 1;

  ideal I = x^2,z^4;
  I = insertGenerator(I,y^3); I;

  J;

  I = insertGenerator(I,y^3,20); I; 

  J;
  I = deleteGenerator(I,20); I;

  J;

  module M = I;
  M = insertGenerator(M,[x^3,y^2,z],22); M; 

  J;

  M = deleteGenerator(M,22); M;
  J;


  kill J;

  ideal J = x^2,z^4;

  J = insertGenerator(J,y^3); J;
  J = insertGenerator(J,y^3,2); J;
  J = deleteGenerator(J,2); J;

  kill J;
  module J = I;
  J = insertGenerator(J,[x^3,y^2,z],21); J;
  J = deleteGenerator(J,21); J;

  kill basering;





 "EXAMPLE:"; echo = 2;
  ring r = 0,(x,y,z,s),Dp;
  ideal I = -1,-4/3,-5/3,-2;
  intvec mI = 2,0,-1,1;
  list BS = I,mI;
  poly p = fl2poly(BS,"s"); // suggestion: variable name....? maybe a polynomial instead?
  p; // wrong result due to bad powers...? no checks. Why no error message???
  factorize(p,2);

  kill basering;



$$$

